#ifndef INPUTSFINDER_H___
#define INPUTSFINDER_H___

#pragma once

#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace GeoFilterBank {

	ref class MainWindow;
	ref class LayerContainer;

	public ref class InputsFinder : public System::Windows::Forms::Form
	{
	public:
		InputsFinder(MainWindow^ mw, xml_node^ fs)
		{
			InitializeComponent();

			usable = true;
			mainWindow = mw;

			CreateAdditionalControls(fs);

			if (!usable) Button_OK->Enabled = false;
		}

	protected:
		~InputsFinder()
		{
			if (components)
			{
				delete components;
			}
		}
	private: 
		System::Windows::Forms::Button^		Button_OK;
		System::Windows::Forms::Button^		Button_Cancel;
		System::Windows::Forms::Label^		Note;
		System::Windows::Forms::Label^		label2;
		System::Windows::Forms::Label^		label3;
		System::Windows::Forms::ImageList^  iconSet;
		System::ComponentModel::IContainer^ components;

		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(InputsFinder::typeid));
			this->Button_OK = (gcnew System::Windows::Forms::Button());
			this->Button_Cancel = (gcnew System::Windows::Forms::Button());
			this->Note = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->iconSet = (gcnew System::Windows::Forms::ImageList(this->components));
			this->SuspendLayout();
			// 
			// Button_OK
			// 
			this->Button_OK->Location = System::Drawing::Point(231, 222);
			this->Button_OK->Name = L"Button_OK";
			this->Button_OK->Size = System::Drawing::Size(75, 23);
			this->Button_OK->TabIndex = 0;
			this->Button_OK->Text = L"Tovbb";
			this->Button_OK->UseVisualStyleBackColor = true;
			this->Button_OK->Click += gcnew System::EventHandler(this, &InputsFinder::Button_OK_Click);
			// 
			// Button_Cancel
			// 
			this->Button_Cancel->Location = System::Drawing::Point(311, 222);
			this->Button_Cancel->Name = L"Button_Cancel";
			this->Button_Cancel->Size = System::Drawing::Size(75, 23);
			this->Button_Cancel->TabIndex = 1;
			this->Button_Cancel->Text = L"Mgsem";
			this->Button_Cancel->UseVisualStyleBackColor = true;
			this->Button_Cancel->Click += gcnew System::EventHandler(this, &InputsFinder::Button_Cancel_Click);
			// 
			// Note
			// 
			this->Note->Location = System::Drawing::Point(31, 18);
			this->Note->Name = L"Note";
			this->Note->Size = System::Drawing::Size(400, 40);
			this->Note->TabIndex = 2;
			this->Note->Text = L"A hasznlni kvnt szr belltsait itt vgezheti el, hogy az egyes bemeneteihe" 
				L"z mely alkalmazhat rteg kerljn prostsra.";
			this->Note->TextAlign = System::Drawing::ContentAlignment::MiddleLeft;
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(31, 83);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(52, 13);
			this->label2->TabIndex = 5;
			this->label2->Text = L"Bemenet:";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(111, 83);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(39, 13);
			this->label3->TabIndex = 6;
			this->label3->Text = L"Rteg:";
			// 
			// iconSet
			// 
			this->iconSet->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"iconSet.ImageStream")));
			this->iconSet->TransparentColor = System::Drawing::Color::Transparent;
			this->iconSet->Images->SetKeyName(0, L"info.gif");
			this->iconSet->Images->SetKeyName(1, L"asterisk.gif");
			// 
			// InputsFinder
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(434, 268);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->Note);
			this->Controls->Add(this->Button_Cancel);
			this->Controls->Add(this->Button_OK);
			this->Name = L"InputsFinder";
			this->Text = L"Forrs keres";
			this->ResumeLayout(false);
			this->PerformLayout();

		}


		void CreateAdditionalControls(xml_node^ fs);
		void Button_OK_Click(System::Object^  sender, System::EventArgs^  e);
		void Button_Cancel_Click(System::Object^  sender, System::EventArgs^  e);
		void pictureBox_Click(System::Object^  sender, System::EventArgs^  e);
	public:
		static bool IsLayerCompatible(LayerContainer^ lc, xml_node^ fs, bool debug_mode);

	private:
		MainWindow^ mainWindow;
		List< ComboBox^ > comboBoxes;
		List< List<LayerContainer^>^ > comboBoxesReferences;
		bool usable;
};
}

#endif

