#ifndef MAINWINDOW_H___
#define MAINWINDOW_H___

#pragma once

#include "stdafx.h"

#define CLICK_SELECT          0
#define IMAGE_VIEW            1
#define MULTIRECTANGLE_SELECT 2
#define MULTIPOLIGON_SELECT   3

#define NONE      0
#define RECTANGLE 1
#define POLIGON   2


using namespace System;
using namespace System::IO;
using namespace System::Collections;
using namespace System::Collections::Generic;
using namespace System::ComponentModel;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;
using namespace System::Text;
using namespace System::Windows::Forms;
using namespace System::Drawing;
using namespace System::Reflection;
using namespace System::Threading;

namespace GeoFilterBank
{
	ref class MainWindow;
	ref class Toolbox;
	ref class LayerContainer;
	ref class InputsFinder;
	ref class SplashScreen;
	ref class WorkflowManager;

	public ref class MainWindow : public System::Windows::Forms::Form
	{
	public:
		MainWindow();

	protected:
		~MainWindow()
		{
			if (components) delete components;
		}

	#pragma region CONTROL_VARIABLES
	private: 
		System::Windows::Forms::MenuStrip^			menuStrip1;
		System::Windows::Forms::ToolStripMenuItem^  menuFile;
		System::Windows::Forms::ToolStripMenuItem^  menuFileOpenImage;
		System::Windows::Forms::ToolStripMenuItem^  menuFileCloseWorkspace;
	public:
		System::Windows::Forms::ToolStripMenuItem^  menuFileSave;
	private:
		System::Windows::Forms::ToolStripSeparator^ toolStripMenuItem1;
		System::Windows::Forms::ToolStripMenuItem^  menuFileExit;
		System::Windows::Forms::ToolStripMenuItem^  menuEdit;
		System::Windows::Forms::ToolStripMenuItem^  menuEditSelectNone;
		System::Windows::Forms::ToolStripMenuItem^  menuEditSelectionToImage;
	public:
		System::Windows::Forms::ToolStripMenuItem^  menuFilter;
	private:
		System::Windows::Forms::ToolStripMenuItem^  menuFilterOverWriteToolStripMenuItem;
		System::Windows::Forms::ToolStripMenuItem^  menuFilterOverwriteAlwaysAsk;
		System::Windows::Forms::ToolStripMenuItem^  menuFilterOverwriteIfPossible;
		System::Windows::Forms::ToolStripMenuItem^  menuFilternCore;
		System::Windows::Forms::ToolStripMenuItem^  menuView;
		System::Windows::Forms::ToolStripMenuItem^  menuViewToolbox;
		System::Windows::Forms::ToolStripMenuItem^  menuViewDeveloperMode;
		System::Windows::Forms::ToolStripMenuItem^  menuViewImageInformation;
		System::Windows::Forms::ToolStripMenuItem^  menuViewWorkflow;
		System::Windows::Forms::ToolStripMenuItem^  menuLanguage;
		System::Windows::Forms::OpenFileDialog^		openFileDialog;
		System::ComponentModel::IContainer^			components;
		System::Windows::Forms::ImageList^			menuFileImageList;
		System::Windows::Forms::ImageList^			menuViewImageList;
		System::Windows::Forms::ImageList^			menuFilterImageList;
		System::Windows::Forms::ImageList^			menuEditImageList;
		System::Windows::Forms::SaveFileDialog^		saveFileDialog;

	public: 
		System::Windows::Forms::ToolStripMenuItem^  menuViewSelections;
		System::Windows::Forms::ToolStripMenuItem^  menuFilterRefresh;
		System::Windows::Forms::ToolStripMenuItem^  menuViewScrollBars;

	#pragma endregion

		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(MainWindow::typeid));
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->menuFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileOpenImage = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileSave = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileCloseWorkspace = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->toolStripMenuItem1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuFileExit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuEdit = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuEditSelectNone = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuEditSelectionToImage = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilter = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilterOverWriteToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilterOverwriteAlwaysAsk = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilterOverwriteIfPossible = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilterRefresh = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFilternCore = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuView = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewWorkflow = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewToolbox = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewSelections = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewScrollBars = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewDeveloperMode = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuViewImageInformation = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuLanguage = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->openFileDialog = (gcnew System::Windows::Forms::OpenFileDialog());
			this->menuFileImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->menuViewImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->menuFilterImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->menuEditImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->saveFileDialog = (gcnew System::Windows::Forms::SaveFileDialog());
			this->menuStrip1->SuspendLayout();
			this->SuspendLayout();
			// 
			// menuStrip1
			// 
			this->menuStrip1->BackColor = System::Drawing::Color::Gainsboro;
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->menuFile, this->menuEdit, 
				this->menuFilter, this->menuView, this->menuLanguage});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(871, 24);
			this->menuStrip1->TabIndex = 2;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// menuFile
			// 
			this->menuFile->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->menuFileOpenImage, 
				this->menuFileSave, this->menuFileCloseWorkspace, this->toolStripMenuItem1, this->menuFileExit});
			this->menuFile->ForeColor = System::Drawing::Color::Black;
			this->menuFile->Name = L"menuFile";
			this->menuFile->Size = System::Drawing::Size(37, 20);
			this->menuFile->Text = L"Fjl";
			// 
			// menuFileOpenImage
			// 
			this->menuFileOpenImage->Name = L"menuFileOpenImage";
			this->menuFileOpenImage->Size = System::Drawing::Size(192, 22);
			this->menuFileOpenImage->Text = L"Megnyits (GEO API)";
			this->menuFileOpenImage->Click += gcnew System::EventHandler(this, &MainWindow::menuFileOpenImage_Click);
			// 
			// menuFileSave
			// 
			this->menuFileSave->Name = L"menuFileSave";
			this->menuFileSave->Size = System::Drawing::Size(192, 22);
			this->menuFileSave->Text = L"Ments";
			// 
			// menuFileCloseWorkspace
			// 
			this->menuFileCloseWorkspace->Name = L"menuFileCloseWorkspace";
			this->menuFileCloseWorkspace->Size = System::Drawing::Size(192, 22);
			this->menuFileCloseWorkspace->Text = L"Munka bezrsa";
			this->menuFileCloseWorkspace->Click += gcnew System::EventHandler(this, &MainWindow::menuFileCloseWorkspace_Click);
			// 
			// toolStripMenuItem1
			// 
			this->toolStripMenuItem1->Name = L"toolStripMenuItem1";
			this->toolStripMenuItem1->Size = System::Drawing::Size(189, 6);
			// 
			// menuFileExit
			// 
			this->menuFileExit->Name = L"menuFileExit";
			this->menuFileExit->Size = System::Drawing::Size(192, 22);
			this->menuFileExit->Text = L"Kilps";
			this->menuFileExit->Click += gcnew System::EventHandler(this, &MainWindow::menuFileExit_Click);
			// 
			// menuEdit
			// 
			this->menuEdit->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->menuEditSelectNone, 
				this->menuEditSelectionToImage});
			this->menuEdit->ForeColor = System::Drawing::Color::Black;
			this->menuEdit->Name = L"menuEdit";
			this->menuEdit->Size = System::Drawing::Size(77, 20);
			this->menuEdit->Text = L"Szerkeszts";
			// 
			// menuEditSelectNone
			// 
			this->menuEditSelectNone->Name = L"menuEditSelectNone";
			this->menuEditSelectNone->Size = System::Drawing::Size(200, 22);
			this->menuEditSelectNone->Text = L"sszes kijells trlse";
			this->menuEditSelectNone->Click += gcnew System::EventHandler(this, &MainWindow::menuEditSelectNone_Click);
			// 
			// menuEditSelectionToImage
			// 
			this->menuEditSelectionToImage->Name = L"menuEditSelectionToImage";
			this->menuEditSelectionToImage->Size = System::Drawing::Size(200, 22);
			this->menuEditSelectionToImage->Text = L"Kijells --> Kp";
			this->menuEditSelectionToImage->Click += gcnew System::EventHandler(this, &MainWindow::menuEditSelectionToImage_Click);
			// 
			// menuFilter
			// 
			this->menuFilter->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {this->menuFilterOverWriteToolStripMenuItem, 
				this->menuFilterRefresh, this->menuFilternCore});
			this->menuFilter->ForeColor = System::Drawing::Color::Black;
			this->menuFilter->Name = L"menuFilter";
			this->menuFilter->Size = System::Drawing::Size(54, 20);
			this->menuFilter->Text = L"Szrk";
			// 
			// menuFilterOverWriteToolStripMenuItem
			// 
			this->menuFilterOverWriteToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->menuFilterOverwriteAlwaysAsk, 
				this->menuFilterOverwriteIfPossible});
			this->menuFilterOverWriteToolStripMenuItem->Name = L"menuFilterOverWriteToolStripMenuItem";
			this->menuFilterOverWriteToolStripMenuItem->Size = System::Drawing::Size(202, 22);
			this->menuFilterOverWriteToolStripMenuItem->Text = L"Fellrsi md";
			// 
			// menuFilterOverwriteAlwaysAsk
			// 
			this->menuFilterOverwriteAlwaysAsk->Checked = true;
			this->menuFilterOverwriteAlwaysAsk->CheckState = System::Windows::Forms::CheckState::Checked;
			this->menuFilterOverwriteAlwaysAsk->Name = L"menuFilterOverwriteAlwaysAsk";
			this->menuFilterOverwriteAlwaysAsk->Size = System::Drawing::Size(191, 22);
			this->menuFilterOverwriteAlwaysAsk->Text = L"Mindig rkrdez";
			this->menuFilterOverwriteAlwaysAsk->Click += gcnew System::EventHandler(this, &MainWindow::menuFilterOverwriteAlwaysAsk_Click);
			// 
			// menuFilterOverwriteIfPossible
			// 
			this->menuFilterOverwriteIfPossible->Name = L"menuFilterOverwriteIfPossible";
			this->menuFilterOverwriteIfPossible->Size = System::Drawing::Size(191, 22);
			this->menuFilterOverwriteIfPossible->Text = L"Fellr, ha lehetsges";
			this->menuFilterOverwriteIfPossible->Click += gcnew System::EventHandler(this, &MainWindow::menuFilterOverwriteIfPossible_Click);
			// 
			// menuFilterRefresh
			// 
			this->menuFilterRefresh->Name = L"menuFilterRefresh";
			this->menuFilterRefresh->Size = System::Drawing::Size(202, 22);
			this->menuFilterRefresh->Text = L"Szrlista frisstse";
			this->menuFilterRefresh->Click += gcnew System::EventHandler(this, &MainWindow::menuFilterRefresh_Click);
			// 
			// menuFilternCore
			// 
			this->menuFilternCore->Checked = true;
			this->menuFilternCore->CheckState = System::Windows::Forms::CheckState::Checked;
			this->menuFilternCore->Name = L"menuFilternCore";
			this->menuFilternCore->Size = System::Drawing::Size(202, 22);
			this->menuFilternCore->Text = L"nCore! MultiThreading";
			this->menuFilternCore->Click += gcnew System::EventHandler(this, &MainWindow::menuFilternCore_Click);
			// 
			// menuView
			// 
			this->menuView->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->menuViewWorkflow, 
				this->menuViewToolbox, this->menuViewSelections, this->menuViewScrollBars, this->menuViewDeveloperMode, this->menuViewImageInformation});
			this->menuView->ForeColor = System::Drawing::Color::Black;
			this->menuView->Name = L"menuView";
			this->menuView->Size = System::Drawing::Size(49, 20);
			this->menuView->Text = L"Nzet";
			// 
			// menuViewWorkflow
			// 
			this->menuViewWorkflow->Name = L"menuViewWorkflow";
			this->menuViewWorkflow->Size = System::Drawing::Size(193, 22);
			this->menuViewWorkflow->Text = L"Workflow Menedzser";
			this->menuViewWorkflow->Click += gcnew System::EventHandler(this, &MainWindow::menuViewWorkflow_Click);
			// 
			// menuViewToolbox
			// 
			this->menuViewToolbox->Name = L"menuViewToolbox";
			this->menuViewToolbox->Size = System::Drawing::Size(193, 22);
			this->menuViewToolbox->Text = L"Eszkztr";
			this->menuViewToolbox->Click += gcnew System::EventHandler(this, &MainWindow::menuViewToolbox_Click);
			// 
			// menuViewSelections
			// 
			this->menuViewSelections->Name = L"menuViewSelections";
			this->menuViewSelections->Size = System::Drawing::Size(193, 22);
			this->menuViewSelections->Text = L"Kijellsek";
			this->menuViewSelections->Click += gcnew System::EventHandler(this, &MainWindow::menuViewSelections_Click);
			// 
			// menuViewScrollBars
			// 
			this->menuViewScrollBars->Name = L"menuViewScrollBars";
			this->menuViewScrollBars->Size = System::Drawing::Size(193, 22);
			this->menuViewScrollBars->Text = L"Grdtsvok";
			this->menuViewScrollBars->Click += gcnew System::EventHandler(this, &MainWindow::menuViewScrollBars_Click);
			// 
			// menuViewDeveloperMode
			// 
			this->menuViewDeveloperMode->Name = L"menuViewDeveloperMode";
			this->menuViewDeveloperMode->Size = System::Drawing::Size(193, 22);
			this->menuViewDeveloperMode->Text = L"Fejleszti zemmd";
			this->menuViewDeveloperMode->Click += gcnew System::EventHandler(this, &MainWindow::menuViewDeveloperMode_Click);
			// 
			// menuViewImageInformation
			// 
			this->menuViewImageInformation->Name = L"menuViewImageInformation";
			this->menuViewImageInformation->Size = System::Drawing::Size(193, 22);
			this->menuViewImageInformation->Text = L"Kp informci";
			this->menuViewImageInformation->Click += gcnew System::EventHandler(this, &MainWindow::menuViewImageInformation_Click);
			// 
			// menuLanguage
			// 
			this->menuLanguage->ForeColor = System::Drawing::Color::Black;
			this->menuLanguage->Name = L"menuLanguage";
			this->menuLanguage->Size = System::Drawing::Size(49, 20);
			this->menuLanguage->Text = L"Nyelv";
			// 
			// menuFileImageList
			// 
			this->menuFileImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"menuFileImageList.ImageStream")));
			this->menuFileImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->menuFileImageList->Images->SetKeyName(0, L"file_open.gif");
			this->menuFileImageList->Images->SetKeyName(1, L"file_save.gif");
			this->menuFileImageList->Images->SetKeyName(2, L"file_close.gif");
			this->menuFileImageList->Images->SetKeyName(3, L"file_exit.gif");
			// 
			// menuViewImageList
			// 
			this->menuViewImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"menuViewImageList.ImageStream")));
			this->menuViewImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->menuViewImageList->Images->SetKeyName(0, L"workflow.gif");
			this->menuViewImageList->Images->SetKeyName(1, L"view_toolbox.gif");
			this->menuViewImageList->Images->SetKeyName(2, L"view_selections.gif");
			this->menuViewImageList->Images->SetKeyName(3, L"view_scrollbars.gif");
			this->menuViewImageList->Images->SetKeyName(4, L"view_developer.gif");
			this->menuViewImageList->Images->SetKeyName(5, L"view_imageinfo.gif");
			// 
			// menuFilterImageList
			// 
			this->menuFilterImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"menuFilterImageList.ImageStream")));
			this->menuFilterImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->menuFilterImageList->Images->SetKeyName(0, L"filter_refreshlist.gif");
			this->menuFilterImageList->Images->SetKeyName(1, L"filter_download.gif");
			this->menuFilterImageList->Images->SetKeyName(2, L"filter_overwrite.gif");
			this->menuFilterImageList->Images->SetKeyName(3, L"filter_filter.gif");
			// 
			// menuEditImageList
			// 
			this->menuEditImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"menuEditImageList.ImageStream")));
			this->menuEditImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->menuEditImageList->Images->SetKeyName(0, L"edit_none.gif");
			this->menuEditImageList->Images->SetKeyName(1, L"edit_selection_to_image.gif");
			// 
			// MainWindow
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Gray;
			this->ClientSize = System::Drawing::Size(871, 527);
			this->Controls->Add(this->menuStrip1);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->IsMdiContainer = true;
			this->Name = L"MainWindow";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Geo FilterBank";
			this->Shown += gcnew System::EventHandler(this, &MainWindow::MainWindow_Shown);
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}

	public:
		Object^ LoadDllMethod(String^ title_class, String^ title_void, String^ path, array<Object^>^ parameters);
		void RefreshFilterList();
		int  FindFilterNamePlace(String^ name, ToolStripMenuItem^ item, int from, int to);
		void RefreshImageLoaderList();
		void RefreshImageSaverList();
		void RefreshLanguageList();
		void ToolBoxClose();
		void WorkflowManagerClose();

	private:
		void MainWindow_Shown(System::Object^  sender, System::EventArgs^  e) 
		{
			this->TopMost = true;
			this->BringToFront();
			this->Activate();
			this->TopMost = false;
		}

		void menuFileOpenImage_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileSaveImage_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileCloseWorkspace_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileExit_Click(System::Object^  sender, System::EventArgs^  e);
		
		void menuEditSelectNone_Click(System::Object^  sender, System::EventArgs^  e);
		void menuEditSelectionToImage_Click(System::Object^  sender, System::EventArgs^  e);
		
		void menuFilterOverwriteAlwaysAsk_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFilterOverwriteIfPossible_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFilterRefresh_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFilterFilterExecute_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFilternCore_Click(System::Object^  sender, System::EventArgs^  e);
		void Filter_Execute(String^ dll_name, String^ filter_name);
		bool Filter_SearchForInputs(xml_node^ filtersetting);
		void Filter_AllocPointers(xml_node^ root, xml_node^ iroot);
		bool Filter_CreateMask(xml_node^& filtersetting, String^ dll, int Width, int Height, LayerContainer^& lc);
		void Filter_DestroyImageMask(xml_node^ root);

		void menuViewWorkflow_Click(System::Object^  sender, System::EventArgs^  e);
		void menuViewToolbox_Click(System::Object^  sender, System::EventArgs^  e);
		void menuViewSelections_Click(System::Object^  sender, System::EventArgs^  e);
		void menuViewScrollBars_Click(System::Object^  sender, System::EventArgs^  e);
		void menuViewDeveloperMode_Click(System::Object^  sender, System::EventArgs^  e);
		void menuViewImageInformation_Click(System::Object^  sender, System::EventArgs^  e);
	
		void menuLanguage_Click(System::Object^  sender, System::EventArgs^  e);

	private:
		bool			splashscreen_shown;
		SplashScreen^	splashsreen;

	public:
		bool					debug_mode, toolbox_exist, workflowmanager_exist;
		Toolbox^				toolbox;
		WorkflowManager^		workflowmanager;
		xml_node^				language_container;
		List< LayerContainer^ >	layers_for_filter;
		System::Collections::Generic::List<KeyValuePair<String^, String^>> image_plugins;
	};

}

#endif

