#pragma once

#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace GeoFilterBank {

	public ref class ProcessStatus : public System::Windows::Forms::Form
	{
	public:
		ProcessStatus(int* _counter, int* _size, bool* result, xml_node^ language)
		{
			language_container = language;
			counter = _counter;
			size = _size;
			prevcount = 0;
			res = result;
			InitializeComponent();
			AbortButton->Text = language_container->XmlGetChildStringValueByName("AbortButtonText");
			StartTime = DateTime::Now;
			StatusChecker->Start();
		}

	protected:

		~ProcessStatus()
		{
			if (components)
			{
				delete components;
			}
		}
	private: 
		System::Windows::Forms::ProgressBar^  StatusProgressBar;
		System::Windows::Forms::Label^  StatusLabel;
		System::Windows::Forms::Button^  AbortButton;
		System::Windows::Forms::Timer^  StatusChecker;
		System::Windows::Forms::Label^  RemainTime;
		System::Windows::Forms::PictureBox^  PictureBoxProcessAnimation;
	public: System::Windows::Forms::Label^  LabelVersionLogo;
	private: 

		System::ComponentModel::IContainer^  components;
		System::DateTime StartTime;

#pragma region Windows Form Designer generated code
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(ProcessStatus::typeid));
			this->StatusProgressBar = (gcnew System::Windows::Forms::ProgressBar());
			this->StatusLabel = (gcnew System::Windows::Forms::Label());
			this->AbortButton = (gcnew System::Windows::Forms::Button());
			this->StatusChecker = (gcnew System::Windows::Forms::Timer(this->components));
			this->RemainTime = (gcnew System::Windows::Forms::Label());
			this->PictureBoxProcessAnimation = (gcnew System::Windows::Forms::PictureBox());
			this->LabelVersionLogo = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxProcessAnimation))->BeginInit();
			this->SuspendLayout();
			// 
			// StatusProgressBar
			// 
			this->StatusProgressBar->Location = System::Drawing::Point(54, 42);
			this->StatusProgressBar->Name = L"StatusProgressBar";
			this->StatusProgressBar->Size = System::Drawing::Size(302, 13);
			this->StatusProgressBar->TabIndex = 0;
			// 
			// StatusLabel
			// 
			this->StatusLabel->AutoSize = true;
			this->StatusLabel->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->StatusLabel->ForeColor = System::Drawing::Color::White;
			this->StatusLabel->Location = System::Drawing::Point(362, 42);
			this->StatusLabel->Name = L"StatusLabel";
			this->StatusLabel->Size = System::Drawing::Size(27, 13);
			this->StatusLabel->TabIndex = 1;
			this->StatusLabel->Text = L"0 %";
			// 
			// AbortButton
			// 
			this->AbortButton->Location = System::Drawing::Point(161, 68);
			this->AbortButton->Name = L"AbortButton";
			this->AbortButton->Size = System::Drawing::Size(85, 23);
			this->AbortButton->TabIndex = 2;
			this->AbortButton->Text = L"Abort";
			this->AbortButton->UseVisualStyleBackColor = true;
			this->AbortButton->Click += gcnew System::EventHandler(this, &ProcessStatus::AbortButton_Click);
			// 
			// StatusChecker
			// 
			this->StatusChecker->Interval = 50;
			this->StatusChecker->Tick += gcnew System::EventHandler(this, &ProcessStatus::StatusChecker_Tick);
			// 
			// RemainTime
			// 
			this->RemainTime->AutoSize = true;
			this->RemainTime->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->RemainTime->ForeColor = System::Drawing::Color::White;
			this->RemainTime->Location = System::Drawing::Point(51, 26);
			this->RemainTime->Name = L"RemainTime";
			this->RemainTime->Size = System::Drawing::Size(87, 13);
			this->RemainTime->TabIndex = 3;
			this->RemainTime->Text = L"Htralv id:";
			// 
			// PictureBoxProcessAnimation
			// 
			this->PictureBoxProcessAnimation->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"PictureBoxProcessAnimation.Image")));
			this->PictureBoxProcessAnimation->Location = System::Drawing::Point(16, 31);
			this->PictureBoxProcessAnimation->Name = L"PictureBoxProcessAnimation";
			this->PictureBoxProcessAnimation->Size = System::Drawing::Size(32, 32);
			this->PictureBoxProcessAnimation->TabIndex = 4;
			this->PictureBoxProcessAnimation->TabStop = false;
			// 
			// LabelVersionLogo
			// 
			this->LabelVersionLogo->AutoSize = true;
			this->LabelVersionLogo->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Regular, 
				System::Drawing::GraphicsUnit::Point, static_cast<System::Byte>(238)));
			this->LabelVersionLogo->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(255)), 
				static_cast<System::Int32>(static_cast<System::Byte>(128)), static_cast<System::Int32>(static_cast<System::Byte>(128)));
			this->LabelVersionLogo->Location = System::Drawing::Point(331, 91);
			this->LabelVersionLogo->Name = L"LabelVersionLogo";
			this->LabelVersionLogo->Size = System::Drawing::Size(80, 13);
			this->LabelVersionLogo->TabIndex = 5;
			this->LabelVersionLogo->Text = L"n!Core Enabled";
			this->LabelVersionLogo->Visible = false;
			// 
			// ProcessStatus
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::SteelBlue;
			this->ClientSize = System::Drawing::Size(411, 105);
			this->Controls->Add(this->LabelVersionLogo);
			this->Controls->Add(this->PictureBoxProcessAnimation);
			this->Controls->Add(this->RemainTime);
			this->Controls->Add(this->AbortButton);
			this->Controls->Add(this->StatusLabel);
			this->Controls->Add(this->StatusProgressBar);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"ProcessStatus";
			this->Text = L"ProcessStatus";
			this->Shown += gcnew System::EventHandler(this, &ProcessStatus::ProcessStatus_Shown);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxProcessAnimation))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
		void AbortButton_Click(System::Object^  sender, System::EventArgs^  e) 
		{
			this->Close();
		}
		void StatusChecker_Tick(System::Object^  sender, System::EventArgs^  e) 
		{
			if (*res) 
			{
				StatusChecker->Stop();
				this->Close();
			}

			int s = *size;
			int c = *counter;
			if (s > 0 && prevcount < c)
			{
				prevcount = c;
				if (c > 0 && c <= s)
				{
					int value = (int)(((double(c)) * 100.0) / (double(s)));
					if (value < 0) value = 0;
					if (value > StatusProgressBar->Maximum) value = StatusProgressBar->Maximum;
					StatusProgressBar->Value = value;
					StatusLabel->Text = value.ToString() + "%";

					String^ s = language_container->XmlGetChildStringValueByName("RemainTimeLabel");

					TimeSpan duration = DateTime::Now - StartTime;
					int dur_sec = (int)(duration.TotalSeconds);
					dur_sec = (value > 0) ? ((100 * dur_sec) / value - dur_sec) : 0;
					int minute = dur_sec / 60;
					int second = dur_sec % 60;
					String^ ssecond = second.ToString();
					if (ssecond->Length < 2) ssecond = "0" + ssecond;
					RemainTime->Text = String::Format(s, minute.ToString(), ssecond); 
				}
			}
		}

		void ProcessStatus_Shown(System::Object^  sender, System::EventArgs^  e) 
		{
			StartTime = DateTime::Now;
		}

	private:
		int *counter, *size, prevcount;
		bool *res;
		xml_node^ language_container;
		
};
}
