#pragma once

#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;




namespace GeoFilterBank {

	ref class SplashThreadWrapper;

	public ref class SplashScreen : public System::Windows::Forms::Form
	{
	public:
		SplashScreen(void)
		{
			LabelInfo = nullptr;

			InitializeComponent();

			int i = System::Environment::ProcessorCount;
			TextBoxProcessor->Text = Get_Processor_Name() + "\r\n" + i.ToString() + ((i>1) ? " CPU cores, " : " CPU core, ");
			if (Is_Supported_MMX())  TextBoxProcessor->Text += "MMX ";
			if (Is_Supported_SSE())  TextBoxProcessor->Text += "SSE ";
			if (Is_Supported_SSE2()) TextBoxProcessor->Text += "SSE2 ";
			if (Is_Supported_SSE3()) TextBoxProcessor->Text += "SSE3";
		}

		void ShowSplash();
		void CloseSplash();
	protected:
		~SplashScreen()
		{
			if (components)
			{
				delete components;
			}
		}

	public: System::Windows::Forms::Label^			LabelLoadMessages;
	private: System::Windows::Forms::PictureBox^	PictureBoxLoading;

	private: System::Windows::Forms::TextBox^  TextBoxProcessor;
	public: 
	private: 

	private: 
	private: System::ComponentModel::IContainer^	components;
	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>



#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(SplashScreen::typeid));
			this->LabelLoadMessages = (gcnew System::Windows::Forms::Label());
			this->PictureBoxLoading = (gcnew System::Windows::Forms::PictureBox());
			this->TextBoxProcessor = (gcnew System::Windows::Forms::TextBox());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxLoading))->BeginInit();
			this->SuspendLayout();
			// 
			// LabelLoadMessages
			// 
			this->LabelLoadMessages->AutoSize = true;
			this->LabelLoadMessages->BackColor = System::Drawing::Color::White;
			this->LabelLoadMessages->Location = System::Drawing::Point(34, 286);
			this->LabelLoadMessages->Name = L"LabelLoadMessages";
			this->LabelLoadMessages->Size = System::Drawing::Size(90, 13);
			this->LabelLoadMessages->TabIndex = 0;
			this->LabelLoadMessages->Text = L"Loading plugins...";
			// 
			// PictureBoxLoading
			// 
			this->PictureBoxLoading->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"PictureBoxLoading.Image")));
			this->PictureBoxLoading->Location = System::Drawing::Point(12, 283);
			this->PictureBoxLoading->Name = L"PictureBoxLoading";
			this->PictureBoxLoading->Size = System::Drawing::Size(16, 16);
			this->PictureBoxLoading->TabIndex = 1;
			this->PictureBoxLoading->TabStop = false;
			// 
			// TextBoxProcessor
			// 
			this->TextBoxProcessor->BackColor = System::Drawing::Color::White;
			this->TextBoxProcessor->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->TextBoxProcessor->Enabled = false;
			this->TextBoxProcessor->ForeColor = System::Drawing::Color::FromArgb(static_cast<System::Int32>(static_cast<System::Byte>(0)), static_cast<System::Int32>(static_cast<System::Byte>(0)), 
				static_cast<System::Int32>(static_cast<System::Byte>(192)));
			this->TextBoxProcessor->Location = System::Drawing::Point(218, 240);
			this->TextBoxProcessor->Multiline = true;
			this->TextBoxProcessor->Name = L"TextBoxProcessor";
			this->TextBoxProcessor->Size = System::Drawing::Size(227, 41);
			this->TextBoxProcessor->TabIndex = 3;
			this->TextBoxProcessor->Text = L"abc\r\ndef\r\nghi";
			// 
			// SplashScreen
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Lime;
			this->BackgroundImage = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"$this.BackgroundImage")));
			this->ClientSize = System::Drawing::Size(542, 311);
			this->Controls->Add(this->TextBoxProcessor);
			this->Controls->Add(this->PictureBoxLoading);
			this->Controls->Add(this->LabelLoadMessages);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::None;
			this->Name = L"SplashScreen";
			this->ShowInTaskbar = false;
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"SplashScreen";
			this->TransparencyKey = System::Drawing::Color::Lime;
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->PictureBoxLoading))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}

		SplashThreadWrapper^ stw;
	public:
		String^ LabelInfo;
#pragma endregion
	};
}
