#pragma once

#include "stdafx.h"


using namespace System;
using namespace System::IO;
using namespace System::Collections;
using namespace System::Collections::Generic;
using namespace System::ComponentModel;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Drawing::Imaging;
using namespace System::Text;
using namespace System::Windows::Forms;
using namespace System::Drawing;
using namespace System::Reflection;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

namespace GeoFilterBank {

	ref class ThreadWrapper 
	{
	public:
		ThreadWrapper(bool* finish, String^ dll, String^ classname, String^ methodname, array<Object^>^ paramlist, xml_node^ lang_cont)
		{
			res = nullptr;
			finished = finish;
			*finished = false;
			language_container = lang_cont;
			dll_name = dll;
			class_name = classname;
			method_name = methodname;
			parameter_list = paramlist;
		}
		//ThreadWrapper(FilterThreadWrapper%){}

		Object^ LoadDllMethod()
		{
			Assembly^ u = Assembly::LoadFile(dll_name);
			Type^ t = u->GetType(class_name);
			if (t != nullptr)
			{
				MethodInfo^ m = t->GetMethod(method_name);
				if (m != nullptr)
				{
					if (parameter_list->Length >= 1)
						return m->Invoke(nullptr, parameter_list);
					else
						return m->Invoke(nullptr, nullptr);
				}
				else
				{
					Exception^ ex = gcnew Exception(language_container->XmlGetChildStringValueByName("MethodNotFound")  + ": " + method_name);
					throw ex;
				}
			}
			else
			{
				Exception^ ex = gcnew Exception(language_container->XmlGetChildStringValueByName("ClassNotFound") + ": " + class_name);
				throw ex;
			}
		}

		void Start()
		{
			try { res = LoadDllMethod(); }
			catch (Exception^ ex) { MessageBox::Show(ex->Message); }
			*finished = true;
		}

		Object^ res;
		bool* finished;

	private:
		xml_node^ language_container;
		String^ dll_name;
		String^ class_name;
		String^ method_name;
		array<Object^>^ parameter_list;
	};
}