
#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


using namespace GeoFilterBank;


Toolbox::Toolbox(MainWindow^ mainWnd)
{
	InitializeComponent();
	ActiveTool = 0;
	mw = mainWnd;
}

void Toolbox::SetToolboxParameters(int zoom, int activetool)
{
    ActiveTool = activetool;
    Magnifier->Value = zoom;
    MagnifierLabel->Text = zoom.ToString() + "%";
    InitToolbar();
}

void Toolbox::InitToolbar()
{
    ButtonPointClick->Image = imageList->Images[0];
    ButtonPan->Image = imageList->Images[3];
    ButtonRectangleSelect->Image = imageList->Images[6];
    ButtonPolygonSelect->Image = imageList->Images[9];

    int i = ActiveTool * 3 + 2;
    switch (ActiveTool)
    {
        case 0:
            ButtonPointClick->Image = imageList->Images[i];
            break;
        case 1:
            ButtonPan->Image = imageList->Images[i];
            break;
        case 2:
            ButtonRectangleSelect->Image = imageList->Images[i];
            break;
        case 3:
            ButtonPolygonSelect->Image = imageList->Images[i];
            break;
        default:
            break;
    }
}

void Toolbox::Toolbox_Load(System::Object^  sender, System::EventArgs^  e) 
{
	InitToolbar();
	MagnifierImage->Image = imageList->Images[12];
}

void Toolbox::Toolbox_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) 
{
	mw->ToolBoxClose();
}

void Toolbox::ToolButton_MouseLeave(System::Object^  sender, System::EventArgs^  e) 
{
    PictureBox^ p = (PictureBox^)sender;
    int index = p->Location.X / p->Width;
    if (ActiveTool != index) p->Image = imageList->Images[index * 3];
}

void Toolbox::ToolButton_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
{
    PictureBox^ p = (PictureBox^)sender;
    int index = p->Location.X / p->Width;
    if (ActiveTool != index) p->Image = imageList->Images[index * 3 + 1];
}

void Toolbox::ToolButton_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
{
    PictureBox^ p = (PictureBox^)sender;
    int index = p->Location.X / p->Width;
	ActiveTool = index;
    InitToolbar();
	if (mw->MdiChildren->Length != 0)
		((LayerContainer^)mw->ActiveMdiChild)->geoViewer->SetFunctionality(ActiveTool);
}

void Toolbox::Magnifier_Scroll(System::Object^  sender, System::EventArgs^  e) 
{
    MagnifierLabel->Text = Magnifier->Value.ToString() + "%";

	if (mw->MdiChildren->Length != 0) 
		((LayerContainer^)mw->ActiveMdiChild)->geoViewer->SetZoom((float)Magnifier->Value);
}

