#ifndef TOOLBOX_H___
#define TOOLBOX_H___

#pragma once

#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace GeoFilterBank
{
	ref class MainWindow;
	ref class Toolbox;
	ref class LayerContainer;

	public ref class Toolbox : public System::Windows::Forms::Form
	{
	public:
		Toolbox(MainWindow^ mainWnd);
		void SetToolboxParameters(int zoom, int activetool);

	private:
		void InitToolbar();
		void Toolbox_Load(System::Object^  sender, System::EventArgs^  e); 
		void Toolbox_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e); 
		void ToolButton_MouseLeave(System::Object^  sender, System::EventArgs^  e); 
		void ToolButton_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e); 
		void ToolButton_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e); 
		void Magnifier_Scroll(System::Object^  sender, System::EventArgs^  e); 

	protected:
		~Toolbox()
		{
			if (components) delete components;
		}
		//
	private:
		System::Windows::Forms::ImageList^	imageList;
		System::Windows::Forms::PictureBox^	ButtonPointClick;
		System::Windows::Forms::PictureBox^	ButtonPolygonSelect;
		System::Windows::Forms::PictureBox^	MagnifierImage;
		System::Windows::Forms::PictureBox^	ButtonPan;
		System::Windows::Forms::PictureBox^	ButtonRectangleSelect;
		System::Windows::Forms::Label^		MagnifierLabel;
		System::Windows::Forms::TrackBar^	Magnifier;
		System::ComponentModel::IContainer^	components;
	#pragma region Windows Form Designer generated code
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Toolbox::typeid));
			this->imageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->ButtonPointClick = (gcnew System::Windows::Forms::PictureBox());
			this->ButtonPolygonSelect = (gcnew System::Windows::Forms::PictureBox());
			this->MagnifierImage = (gcnew System::Windows::Forms::PictureBox());
			this->ButtonPan = (gcnew System::Windows::Forms::PictureBox());
			this->ButtonRectangleSelect = (gcnew System::Windows::Forms::PictureBox());
			this->MagnifierLabel = (gcnew System::Windows::Forms::Label());
			this->Magnifier = (gcnew System::Windows::Forms::TrackBar());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPointClick))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPolygonSelect))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->MagnifierImage))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPan))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonRectangleSelect))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Magnifier))->BeginInit();
			this->SuspendLayout();
			// 
			// imageList
			// 
			this->imageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"imageList.ImageStream")));
			this->imageList->TransparentColor = System::Drawing::Color::Transparent;
			this->imageList->Images->SetKeyName(0, L"t_wand0.bmp");
			this->imageList->Images->SetKeyName(1, L"t_wand1.bmp");
			this->imageList->Images->SetKeyName(2, L"t_wand2.bmp");
			this->imageList->Images->SetKeyName(3, L"t_pan0.bmp");
			this->imageList->Images->SetKeyName(4, L"t_pan1.bmp");
			this->imageList->Images->SetKeyName(5, L"t_pan2.bmp");
			this->imageList->Images->SetKeyName(6, L"t_select0.bmp");
			this->imageList->Images->SetKeyName(7, L"t_select1.bmp");
			this->imageList->Images->SetKeyName(8, L"t_select2.bmp");
			this->imageList->Images->SetKeyName(9, L"t_polygon0.bmp");
			this->imageList->Images->SetKeyName(10, L"t_polygon1.bmp");
			this->imageList->Images->SetKeyName(11, L"t_polygon2.bmp");
			this->imageList->Images->SetKeyName(12, L"t_zoom1.bmp");
			// 
			// ButtonPointClick
			// 
			this->ButtonPointClick->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->ButtonPointClick->Location = System::Drawing::Point(0, 0);
			this->ButtonPointClick->Name = L"ButtonPointClick";
			this->ButtonPointClick->Size = System::Drawing::Size(30, 26);
			this->ButtonPointClick->TabIndex = 15;
			this->ButtonPointClick->TabStop = false;
			this->ButtonPointClick->MouseLeave += gcnew System::EventHandler(this, &Toolbox::ToolButton_MouseLeave);
			this->ButtonPointClick->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseMove);
			this->ButtonPointClick->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseClick);
			// 
			// ButtonPolygonSelect
			// 
			this->ButtonPolygonSelect->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->ButtonPolygonSelect->Location = System::Drawing::Point(90, 0);
			this->ButtonPolygonSelect->Name = L"ButtonPolygonSelect";
			this->ButtonPolygonSelect->Size = System::Drawing::Size(30, 26);
			this->ButtonPolygonSelect->TabIndex = 14;
			this->ButtonPolygonSelect->TabStop = false;
			this->ButtonPolygonSelect->MouseLeave += gcnew System::EventHandler(this, &Toolbox::ToolButton_MouseLeave);
			this->ButtonPolygonSelect->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseMove);
			this->ButtonPolygonSelect->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseClick);
			// 
			// MagnifierImage
			// 
			this->MagnifierImage->Location = System::Drawing::Point(151, 0);
			this->MagnifierImage->Name = L"MagnifierImage";
			this->MagnifierImage->Size = System::Drawing::Size(30, 26);
			this->MagnifierImage->TabIndex = 13;
			this->MagnifierImage->TabStop = false;
			// 
			// ButtonPan
			// 
			this->ButtonPan->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->ButtonPan->Location = System::Drawing::Point(30, 0);
			this->ButtonPan->Name = L"ButtonPan";
			this->ButtonPan->Size = System::Drawing::Size(30, 26);
			this->ButtonPan->TabIndex = 12;
			this->ButtonPan->TabStop = false;
			this->ButtonPan->MouseLeave += gcnew System::EventHandler(this, &Toolbox::ToolButton_MouseLeave);
			this->ButtonPan->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseMove);
			this->ButtonPan->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseClick);
			// 
			// ButtonRectangleSelect
			// 
			this->ButtonRectangleSelect->BorderStyle = System::Windows::Forms::BorderStyle::FixedSingle;
			this->ButtonRectangleSelect->Location = System::Drawing::Point(60, 0);
			this->ButtonRectangleSelect->Name = L"ButtonRectangleSelect";
			this->ButtonRectangleSelect->Size = System::Drawing::Size(30, 26);
			this->ButtonRectangleSelect->TabIndex = 11;
			this->ButtonRectangleSelect->TabStop = false;
			this->ButtonRectangleSelect->Tag = L"";
			this->ButtonRectangleSelect->MouseLeave += gcnew System::EventHandler(this, &Toolbox::ToolButton_MouseLeave);
			this->ButtonRectangleSelect->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseMove);
			this->ButtonRectangleSelect->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &Toolbox::ToolButton_MouseClick);
			// 
			// MagnifierLabel
			// 
			this->MagnifierLabel->AutoSize = true;
			this->MagnifierLabel->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 8.25F, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(238)));
			this->MagnifierLabel->Location = System::Drawing::Point(332, 6);
			this->MagnifierLabel->Name = L"MagnifierLabel";
			this->MagnifierLabel->Size = System::Drawing::Size(37, 13);
			this->MagnifierLabel->TabIndex = 10;
			this->MagnifierLabel->Text = L"100%";
			// 
			// Magnifier
			// 
			this->Magnifier->Cursor = System::Windows::Forms::Cursors::Hand;
			this->Magnifier->LargeChange = 50;
			this->Magnifier->Location = System::Drawing::Point(187, 0);
			this->Magnifier->Maximum = 400;
			this->Magnifier->Minimum = 10;
			this->Magnifier->Name = L"Magnifier";
			this->Magnifier->Size = System::Drawing::Size(139, 45);
			this->Magnifier->SmallChange = 10;
			this->Magnifier->TabIndex = 9;
			this->Magnifier->TickStyle = System::Windows::Forms::TickStyle::None;
			this->Magnifier->Value = 100;
			this->Magnifier->Scroll += gcnew System::EventHandler(this, &Toolbox::Magnifier_Scroll);
			// 
			// Toolbox
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(380, 26);
			this->Controls->Add(this->ButtonPointClick);
			this->Controls->Add(this->ButtonPolygonSelect);
			this->Controls->Add(this->MagnifierImage);
			this->Controls->Add(this->ButtonPan);
			this->Controls->Add(this->ButtonRectangleSelect);
			this->Controls->Add(this->MagnifierLabel);
			this->Controls->Add(this->Magnifier);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"Toolbox";
			this->Text = L"Toolbox";
			this->TopMost = true;
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Toolbox::Toolbox_FormClosing);
			this->Load += gcnew System::EventHandler(this, &Toolbox::Toolbox_Load);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPointClick))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPolygonSelect))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->MagnifierImage))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonPan))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->ButtonRectangleSelect))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Magnifier))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
	#pragma endregion

	private:
		int ActiveTool;
		MainWindow^ mw;

	};

}

#endif

