#pragma once

#include "stdafx.h"


namespace GeoFilterBank {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Collections::Generic;

	/// <summary>
	/// Summary for WorkflowManager
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	ref class GraphNode;
	ref class GraphEdge;
	ref class MainWindow;

	public ref class WorkflowManager : public System::Windows::Forms::Form
	{

	public:
		WorkflowManager(MainWindow^ mainwnd);

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~WorkflowManager()
		{
			if (components)
			{
				delete components;
			}

			int c = nodeList->Count;
			for (int i = 0; i < c; i++) delete nodeList[i];
			c = edgeList->Count;
			for (int i = 0; i < c; i++) delete edgeList[i];
		}

	private: 
		System::Collections::Generic::List<GeoFilterBank::GraphNode^>^ nodeList;
		System::Collections::Generic::List<GeoFilterBank::GraphEdge^>^ edgeList;

		System::Windows::Forms::MenuStrip^			menuStrip;
		System::Windows::Forms::ToolStripMenuItem^  menuFile;
		System::Windows::Forms::ToolStripMenuItem^  menuFileOpen;
		System::Windows::Forms::ToolStripMenuItem^  menuFileSave;
		System::Windows::Forms::ToolStripMenuItem^  menuFileSaveAs;
		System::Windows::Forms::ToolStripSeparator^ menuFileSep1;
		System::Windows::Forms::ToolStripMenuItem^  menuFileClose;
		System::Windows::Forms::ToolStripMenuItem^  menuAddComponent;
		System::Windows::Forms::ToolStripMenuItem^  menuAddImport;
		System::Windows::Forms::ToolStripMenuItem^  menuAddExport;
		System::Windows::Forms::ToolStripMenuItem^  menuAddFilter;
		System::Windows::Forms::ImageList^			menuImageList;
		System::Windows::Forms::ToolStripMenuItem^  menuWorkflow;
		System::Windows::Forms::ToolStripMenuItem^  menuWorkflowStart;
	private: System::Windows::Forms::ToolStripMenuItem^  menuAddSplitter;
	private: System::Windows::Forms::ToolStripMenuItem^  menuFileNew;
	private: System::Windows::Forms::ToolStripMenuItem^  menuWorkflowInteractiveMode;
	public: System::Windows::Forms::ToolStripMenuItem^  menuWorkflowShowXMLMetainfos;
	private: System::Windows::Forms::ToolStripMenuItem^  menuAddNullExport;
	private: System::Windows::Forms::HScrollBar^  WorkflowScrollBarH;
	private: System::Windows::Forms::VScrollBar^  WorkflowScrollBarV;
	public: 
	private: 


	public: 
	private: 


		System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(WorkflowManager::typeid));
			this->menuStrip = (gcnew System::Windows::Forms::MenuStrip());
			this->menuFile = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileNew = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileOpen = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileSave = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileSaveAs = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuFileSep1 = (gcnew System::Windows::Forms::ToolStripSeparator());
			this->menuFileClose = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuWorkflow = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddComponent = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddImport = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddExport = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddFilter = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddSplitter = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuAddNullExport = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuWorkflowStart = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuWorkflowInteractiveMode = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuWorkflowShowXMLMetainfos = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->menuImageList = (gcnew System::Windows::Forms::ImageList(this->components));
			this->WorkflowScrollBarH = (gcnew System::Windows::Forms::HScrollBar());
			this->WorkflowScrollBarV = (gcnew System::Windows::Forms::VScrollBar());
			this->menuStrip->SuspendLayout();
			this->SuspendLayout();
			// 
			// menuStrip
			// 
			this->menuStrip->BackColor = System::Drawing::Color::Gainsboro;
			this->menuStrip->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {this->menuFile, this->menuWorkflow});
			this->menuStrip->Location = System::Drawing::Point(0, 0);
			this->menuStrip->Name = L"menuStrip";
			this->menuStrip->Size = System::Drawing::Size(768, 24);
			this->menuStrip->TabIndex = 2;
			this->menuStrip->Text = L"menuStrip";
			// 
			// menuFile
			// 
			this->menuFile->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(6) {this->menuFileNew, 
				this->menuFileOpen, this->menuFileSave, this->menuFileSaveAs, this->menuFileSep1, this->menuFileClose});
			this->menuFile->Name = L"menuFile";
			this->menuFile->Size = System::Drawing::Size(36, 20);
			this->menuFile->Text = L"Fjl";
			// 
			// menuFileNew
			// 
			this->menuFileNew->Name = L"menuFileNew";
			this->menuFileNew->Size = System::Drawing::Size(163, 22);
			this->menuFileNew->Text = L"j";
			this->menuFileNew->Click += gcnew System::EventHandler(this, &WorkflowManager::menuFileNew_Click);
			// 
			// menuFileOpen
			// 
			this->menuFileOpen->Name = L"menuFileOpen";
			this->menuFileOpen->Size = System::Drawing::Size(163, 22);
			this->menuFileOpen->Text = L"Megnyits";
			this->menuFileOpen->Click += gcnew System::EventHandler(this, &WorkflowManager::menuFileOpen_Click);
			// 
			// menuFileSave
			// 
			this->menuFileSave->Name = L"menuFileSave";
			this->menuFileSave->Size = System::Drawing::Size(163, 22);
			this->menuFileSave->Text = L"Ments";
			this->menuFileSave->Click += gcnew System::EventHandler(this, &WorkflowManager::menuFileSave_Click);
			// 
			// menuFileSaveAs
			// 
			this->menuFileSaveAs->Name = L"menuFileSaveAs";
			this->menuFileSaveAs->Size = System::Drawing::Size(163, 22);
			this->menuFileSaveAs->Text = L"Ments msknt";
			this->menuFileSaveAs->Click += gcnew System::EventHandler(this, &WorkflowManager::menuFileSaveAs_Click);
			// 
			// menuFileSep1
			// 
			this->menuFileSep1->Name = L"menuFileSep1";
			this->menuFileSep1->Size = System::Drawing::Size(160, 6);
			// 
			// menuFileClose
			// 
			this->menuFileClose->Name = L"menuFileClose";
			this->menuFileClose->Size = System::Drawing::Size(163, 22);
			this->menuFileClose->Text = L"Bezrs";
			this->menuFileClose->Click += gcnew System::EventHandler(this, &WorkflowManager::menuFileClose_Click);
			// 
			// menuWorkflow
			// 
			this->menuWorkflow->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(4) {this->menuAddComponent, 
				this->menuWorkflowStart, this->menuWorkflowInteractiveMode, this->menuWorkflowShowXMLMetainfos});
			this->menuWorkflow->Name = L"menuWorkflow";
			this->menuWorkflow->Size = System::Drawing::Size(64, 20);
			this->menuWorkflow->Text = L"Workflow";
			// 
			// menuAddComponent
			// 
			this->menuAddComponent->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(5) {this->menuAddImport, 
				this->menuAddExport, this->menuAddFilter, this->menuAddSplitter, this->menuAddNullExport});
			this->menuAddComponent->Name = L"menuAddComponent";
			this->menuAddComponent->Size = System::Drawing::Size(183, 22);
			this->menuAddComponent->Text = L"j komponens";
			// 
			// menuAddImport
			// 
			this->menuAddImport->Name = L"menuAddImport";
			this->menuAddImport->Size = System::Drawing::Size(196, 22);
			this->menuAddImport->Text = L"Import";
			this->menuAddImport->Click += gcnew System::EventHandler(this, &WorkflowManager::menuAddImport_Click);
			// 
			// menuAddExport
			// 
			this->menuAddExport->Name = L"menuAddExport";
			this->menuAddExport->Size = System::Drawing::Size(196, 22);
			this->menuAddExport->Text = L"Export";
			// 
			// menuAddFilter
			// 
			this->menuAddFilter->Name = L"menuAddFilter";
			this->menuAddFilter->Size = System::Drawing::Size(196, 22);
			this->menuAddFilter->Text = L"Szr";
			// 
			// menuAddSplitter
			// 
			this->menuAddSplitter->Name = L"menuAddSplitter";
			this->menuAddSplitter->Size = System::Drawing::Size(196, 22);
			this->menuAddSplitter->Text = L"Splitter";
			this->menuAddSplitter->Click += gcnew System::EventHandler(this, &WorkflowManager::menuAddSplitter_Click);
			// 
			// menuAddNullExport
			// 
			this->menuAddNullExport->Name = L"menuAddNullExport";
			this->menuAddNullExport->Size = System::Drawing::Size(196, 22);
			this->menuAddNullExport->Text = L"Null Export   \"/dev/null\"";
			this->menuAddNullExport->Click += gcnew System::EventHandler(this, &WorkflowManager::menuAddNullExport_Click);
			// 
			// menuWorkflowStart
			// 
			this->menuWorkflowStart->Name = L"menuWorkflowStart";
			this->menuWorkflowStart->Size = System::Drawing::Size(183, 22);
			this->menuWorkflowStart->Text = L"Start";
			this->menuWorkflowStart->Click += gcnew System::EventHandler(this, &WorkflowManager::menuWorkflowStart_Click);
			// 
			// menuWorkflowInteractiveMode
			// 
			this->menuWorkflowInteractiveMode->CheckOnClick = true;
			this->menuWorkflowInteractiveMode->Name = L"menuWorkflowInteractiveMode";
			this->menuWorkflowInteractiveMode->Size = System::Drawing::Size(183, 22);
			this->menuWorkflowInteractiveMode->Text = L"Interactive mode";
			// 
			// menuWorkflowShowXMLMetainfos
			// 
			this->menuWorkflowShowXMLMetainfos->CheckOnClick = true;
			this->menuWorkflowShowXMLMetainfos->Name = L"menuWorkflowShowXMLMetainfos";
			this->menuWorkflowShowXMLMetainfos->Size = System::Drawing::Size(183, 22);
			this->menuWorkflowShowXMLMetainfos->Text = L"Show XML metainfos";
			// 
			// menuImageList
			// 
			this->menuImageList->ImageStream = (cli::safe_cast<System::Windows::Forms::ImageListStreamer^  >(resources->GetObject(L"menuImageList.ImageStream")));
			this->menuImageList->TransparentColor = System::Drawing::Color::Transparent;
			this->menuImageList->Images->SetKeyName(0, L"file_open.gif");
			this->menuImageList->Images->SetKeyName(1, L"file_save.gif");
			this->menuImageList->Images->SetKeyName(2, L"filter_filter.gif");
			this->menuImageList->Images->SetKeyName(3, L"file_close.gif");
			this->menuImageList->Images->SetKeyName(4, L"workflow_add.gif");
			this->menuImageList->Images->SetKeyName(5, L"workflow_run.gif");
			this->menuImageList->Images->SetKeyName(6, L"workflow_splitter.gif");
			// 
			// WorkflowScrollBarH
			// 
			this->WorkflowScrollBarH->Location = System::Drawing::Point(9, 405);
			this->WorkflowScrollBarH->Maximum = 5000;
			this->WorkflowScrollBarH->Name = L"WorkflowScrollBarH";
			this->WorkflowScrollBarH->Size = System::Drawing::Size(677, 16);
			this->WorkflowScrollBarH->TabIndex = 3;
			this->WorkflowScrollBarH->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &WorkflowManager::WorkflowScrollEvent);
			// 
			// WorkflowScrollBarV
			// 
			this->WorkflowScrollBarV->Location = System::Drawing::Point(730, 50);
			this->WorkflowScrollBarV->Maximum = 3000;
			this->WorkflowScrollBarV->Name = L"WorkflowScrollBarV";
			this->WorkflowScrollBarV->Size = System::Drawing::Size(16, 355);
			this->WorkflowScrollBarV->TabIndex = 4;
			this->WorkflowScrollBarV->Scroll += gcnew System::Windows::Forms::ScrollEventHandler(this, &WorkflowManager::WorkflowScrollEvent);
			// 
			// WorkflowManager
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::Color::Gray;
			this->ClientSize = System::Drawing::Size(768, 431);
			this->Controls->Add(this->WorkflowScrollBarV);
			this->Controls->Add(this->WorkflowScrollBarH);
			this->Controls->Add(this->menuStrip);
			this->MainMenuStrip = this->menuStrip;
			this->Name = L"WorkflowManager";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"Workflow Manager";
			this->MouseUp += gcnew System::Windows::Forms::MouseEventHandler(this, &WorkflowManager::WorkflowManager_MouseUp);
			this->Paint += gcnew System::Windows::Forms::PaintEventHandler(this, &WorkflowManager::WorkflowManager_Paint);
			this->MouseDown += gcnew System::Windows::Forms::MouseEventHandler(this, &WorkflowManager::WorkflowManager_MouseDown);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &WorkflowManager::WorkflowManager_FormClosing);
			this->Resize += gcnew System::EventHandler(this, &WorkflowManager::WorkflowManager_Resize);
			this->MouseMove += gcnew System::Windows::Forms::MouseEventHandler(this, &WorkflowManager::WorkflowManager_MouseMove);
			this->menuStrip->ResumeLayout(false);
			this->menuStrip->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: 
		void WorkflowManager_Paint(System::Object^  sender, System::Windows::Forms::PaintEventArgs^  e);
		void WorkflowManager_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e);
		void menuFileNew_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileOpen_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileSave_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileSaveAs_Click(System::Object^  sender, System::EventArgs^  e);
		void menuFileClose_Click(System::Object^  sender, System::EventArgs^  e) { this->Close(); }
		void menuAddImport_Click(System::Object^  sender, System::EventArgs^  e);
		void menuAddExport_Click(System::Object^  sender, System::EventArgs^  e);
		void menuAddFilter_Click(System::Object^  sender, System::EventArgs^  e);
		void menuAddSplitter_Click(System::Object^  sender, System::EventArgs^  e);
		void menuAddNullExport_Click(System::Object^  sender, System::EventArgs^  e);
		void menuWorkflowStart_Click(System::Object^  sender, System::EventArgs^  e);
		void WorkflowManager_Resize(System::Object^  sender, System::EventArgs^  e);
		void WorkflowScrollEvent(System::Object^  sender, System::Windows::Forms::ScrollEventArgs^  e);
		void WorkflowManager_MouseDown(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
		void WorkflowManager_MouseMove(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e);
		void WorkflowManager_MouseUp(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e); 

		void    SaveWorkflow(String^ filename);
		void	AddGraphNode(String^ title, String^ filter_url, GraphNodeType gt);
		void	AddGraphNode(String^ title, String^ filter_url, GraphNodeType gt, System::Drawing::Point location, System::Drawing::Size dimension, bool restore);
		bool	IsComplete();
		int*	DetermineExecutionOrder();
		bool	IsEdgeValid(GraphEdge^ edge);
		bool	CopyImageSetting(xml_node^ fs, xml_node^ fd);
		int     prev_scroll_x, prev_scroll_y;
		int     prev_mouse_x,  prev_mouse_y;
		bool    mouse_button_down;

		MainWindow^ mw;
		String^		WorkflowFile;

	public:
		void CreateEdge(bool forward);
		void DeleteEdge(GraphNode^ gn, int pin);
		void DeleteNode(GraphNode^ gn);
		int  GetPointedNode();
		MainWindow^ GetParent(){ return mw; }

	public:
		GeoFilterBank::GraphNode^ src;
		int  pin;
		int  m_x, m_y, x, y;
		bool edge_construct;

		 
	};


	struct dag_node{ 
		dag_node() : incoming(0) {}
		int incoming;
		std::set<int> neighbours; 
	};
}

