#pragma once

#include "stdafx.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace GeoFilterBank 
{

	public ref class XML_Editor : public System::Windows::Forms::Form
	{
	public:
		XML_Editor(void)
		{
			InitializeComponent();
		}

	protected:
		~XML_Editor()
		{
			if (components)
			{
				delete components;
			}
		}
	private: 
		System::Windows::Forms::TreeView^  XmlTreeView;
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code

		void InitializeComponent(void)
		{
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(XML_Editor::typeid));
			this->XmlTreeView = (gcnew System::Windows::Forms::TreeView());
			this->SuspendLayout();
			// 
			// XmlTreeView
			// 
			this->XmlTreeView->ForeColor = System::Drawing::Color::Navy;
			this->XmlTreeView->HideSelection = false;
			this->XmlTreeView->Location = System::Drawing::Point(0, 0);
			this->XmlTreeView->Name = L"XmlTreeView";
			this->XmlTreeView->Size = System::Drawing::Size(373, 452);
			this->XmlTreeView->TabIndex = 1;
			// 
			// XML_Editor
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(373, 452);
			this->Controls->Add(this->XmlTreeView);
			this->Icon = (cli::safe_cast<System::Drawing::Icon^  >(resources->GetObject(L"$this.Icon")));
			this->Name = L"XML_Editor";
			this->Text = L"XML_Editor";
			this->TopMost = true;
			this->Resize += gcnew System::EventHandler(this, &XML_Editor::XML_Editor_Resize);
			this->ResumeLayout(false);

		}
#pragma endregion

		void XmlFormatTag(TreeNode^ node, String^ name, int level)
		{
			if (name == "InputImageCount")
			{
				node->ForeColor = Color::DarkGoldenrod;
			}
			else if (name->Length >= 10 && name->Substring(0, 10) == "InputImage")
			{
				node->ForeColor = Color::DarkGoldenrod;
			}
			else if (name->Length >= 11 && name->Substring(0, 11) == "OutputImage")
			{
				node->ForeColor = Color::DarkGoldenrod;
			}
			else if (name == "Width")
			{
				node->ForeColor = Color::DarkSlateBlue;
			}
			else if (name == "Height")
			{
				node->ForeColor = Color::DarkSlateBlue;
			}
			else if (name == "Stride")
			{
				node->ForeColor = Color::DarkOrange;
			}
			else if (name == "Packed")
			{
				node->ForeColor = Color::DarkOrange;
			}
			else if (name == "Interleaved")
			{
				node->ForeColor = Color::DarkOrange;
			}
			else  if (name == "ChannelCount")
			{
				node->ForeColor = Color::DarkGreen;
			}
			else  if (name == "PixelSize")
			{
				node->ForeColor = Color::DarkGreen;
			}
			else  if (name == "Data")
			{
				node->ForeColor = Color::Red;
			}
			else  if (name == "ChannelsBitAllocation")
			{
				node->ForeColor = Color::DarkGoldenrod;
			}
			else  if (name->Length >= 7 && name->Substring(0, 7) == "Channel")
			{
				node->ForeColor = Color::DarkGreen;
			}
			else  if (name == "Mask")
			{
				node->ForeColor = Color::DarkGoldenrod;
			}
			else  if (name == "MultiThreading")
			{
				node->ForeColor = Color::Red;
			}
		}

		void XmlRecursiveTreeBuilder(TreeNodeCollection^ current_treenode, xml_node^ current_xmlnode, int level)
		{
			if (current_xmlnode == nullptr || current_treenode == nullptr) return;

			String ^label, ^l2;
			for (int i = 0; i < current_xmlnode->children.Count; i++)
			{
				label = current_xmlnode->children[i]->name;
				l2 = current_xmlnode->children[i]->attributes;
				if (l2->Length > 20) l2 = l2->Substring(0, 20) + "...";
				if (l2->Length) label += " {" + l2 + "}";
				l2 = current_xmlnode->children[i]->value;
				if (l2->Length) label += ": " + l2;
				current_treenode->Add("", label, level, level);
				XmlFormatTag(current_treenode[i], current_xmlnode->children[i]->name, level);
				XmlRecursiveTreeBuilder(current_treenode[i]->Nodes, current_xmlnode->children[i], 1);
			}
		}

		void XML_Editor_Resize(System::Object^  sender, System::EventArgs^  e) 
		{
			XmlTreeView->Width = this->ClientSize.Width - 2;
			XmlTreeView->Height = this->ClientSize.Height - 2;
		}

		//
	public:
		void CreateXMLTree(xml_node^ root)
		{
			XmlTreeView->Nodes->Clear();
			XmlRecursiveTreeBuilder(XmlTreeView->Nodes, root, 0);
		}
	};
}
