#pragma once

using namespace System;
#include <string>
#include <intrin.h>


// FILTER TYPES
#define IMAGEFILTER_PIXELWISE 0
#define IMAGEFILTER_BOX       1
#define IMAGEFILTER_BLOCK     2
#define IMAGEFILTER_RECURSIVE 3

// VERSION GENERATOR MACRO
#ifndef VER_GEN
#define VER_GEN(a,b,c,d) ((a) * 1000000 + (b) * 10000 + (c) * 100 + (d))
#endif

#ifndef byte
typedef unsigned char byte;
#endif

#ifndef MIN
#define MIN(a,b) ((a) < (b)) ? (a) : (b)
#endif

#ifndef MAX
#define MAX(a,b) ((a) < (b)) ? (b) : (a)
#endif

#ifndef INTERVAL_LIMITER
#define INTERVAL_LIMITER(v, a, b) ((v) < (a)) ? (a) : ( ((v) > (b)) ? (b) : (v) )
#endif

#ifndef NCORE_REVERSE_DWORD
#define NCORE_REVERSE_DWORD(x) ((x >> 24) | (x << 24) | ((x >> 8) & 0xff00) | ((x << 8) & 0xff0000))
#endif

#ifndef GFB_COMPARE_FUNCTION_
#define GFB_COMPARE_FUNCTION_
int compare( const void *arg1, const void *arg2 );
#endif

// CONVERT FUNCTIONS  : UPCAST
byte* convert_bitplane_to_byteplane(byte* bitplane, int width, int height, int stridein, int strideout);
byte* convert_byteplane_to_rgbplane(byte* byteplane, int width, int height, int stridein, int strideout);
byte* convert_bitplane_to_rgbplane(byte* bitplane, int width, int height, int stridein, int strideout);
// CONVERT FUNCTIONS  : DOWNCAST
byte* convert_rgbplane_to_bitplane(byte* rgbplane, int width, int height, int stridein, int strideout);


// STRING CONVERSION FUNCTIONS

std::string StringTostring(String^ s);
String^     stringToString(std::string s);
char*       StringToCharstring(String^ s);

std::string base64(const unsigned char* in, int length);
void        base64(std::string strdata, unsigned char*& data, int& length);


// CPU FEATURE DETECTION FUNCTIONS

bool Is_Supported_MMX();
bool Is_Supported_SSE();
bool Is_Supported_SSE2();
bool Is_Supported_SSE3();
String^ Get_Processor_Name();
